<?php

namespace Ulmus\Attribute\Property\Field;

use Ulmus\Attribute\Attribute;

/**
 * Since we need consistancy between the declaration of our ID and FK fields, it
 * was decided to extend the PK class instead of Field for this case.
 */
#[\Attribute(\Attribute::TARGET_PROPERTY)]
class ForeignKey extends PrimaryKey {

    public const SET_NULL = "null";

    public const SET_DEFAULT = "default";

    public const RESTRICT = "restrict";

    public const NO_ACTION = "noaction";

    public const CASCADE = "cascade";

    public function __construct(
        public ? string $name = null,
        public ? string $type = 'bigint',
        public null|int|string $length = null,
        public ? int $precision = null,
        public array $attributes = [
            'primary_key' => false,
            'auto_increment' => false
        ],
        public bool $nullable = false,
        public mixed $default = null,
        public bool $readonly = false,
        public null|array|string|\Stringable $foreignKey = "",
        public null|array|string|\Stringable $references = null,
        public null|string $onDelete = self::NO_ACTION,
        public null|string $onUpdate = self::NO_ACTION,
    ) {
        $this->references = Attribute::handleArrayField($this->references, false);
    }
}
